<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

include_spip('base/ciwidget_install');
include_spip('inc/widget_commun');

function ciwidget_produire_css(){
    static $ciwidget_css = '';
    
    if (!$ciwidget_css) {
        $ciwidget_css = direction_css(produire_fond_statique('_css/ciwidget27.css'), lang_dir());
    }
    
    return $ciwidget_css;
}

function ciwidget_header_prive($flux){
        $css = ciwidget_produire_css();
	$flux .= '<link rel="stylesheet" href="'.$css.'" />';
        
        $css = direction_css(find_in_path('prive/ciwidget_modal31.css'), lang_dir());
	$flux .= '<link rel="stylesheet" href="'.$css.'" />';

        $css = direction_css(find_in_path('lib/splide/splide.min.css'), lang_dir());
	$flux .= '<link rel="stylesheet" href="'.$css.'" />';
        
	$flux .= "<script type='text/javascript' src='".find_in_path('prive/ciwidget_modal.js')."'></script>";
	$flux .= "<script type='text/javascript' src='".find_in_path('_js/ciwidget_v2.js')."'></script>";
	return $flux;
}

function ciwidget_insert_head_css($flux){
        $css = ciwidget_produire_css();
	$flux .= '<link rel="stylesheet" href="'.$css.'" />';

        $css = direction_css(find_in_path('lib/splide/splide.min.css'), lang_dir());
	$flux .= '<link rel="stylesheet" href="'.$css.'" />';
        
	return $flux;
}

function ciwidget_insert_head($flux) {
        $js = find_in_path('_js/ciwidget_v2.js');
        $flux .= "<script type='text/javascript' src='".$js."'></script>";
        
        $tableau_widgets_tarteaucitron = ciwidget_tableau_widgets_tarteaucitron();
        
        // ajout d'un identifiant dans la balise script pour qu'il ne soit pas pris en compte par la compression des scripts (quand elle est activée dans SPIP)
        if (defined('_CIWIDGET_PAS_CHARGER_TARTEAUCITRON') AND _CIWIDGET_PAS_CHARGER_TARTEAUCITRON=='oui'){
            $inserer_tac = false;
        } else {
            if ($tableau_widgets_tarteaucitron){
                $inserer_tac = true;
            } else {
                $inserer_tac = false;
            }
        }
        if ($inserer_tac){
            $flux .= '<script type="text/javascript" src="'.find_in_path("lib/tarteaucitron/tarteaucitron.min.js").'" id="ciwidget_tarteaucitron"></script>';
            $flux .= '<script type="text/javascript">
            tarteaucitron.init({
                "hashtag": "#tarteaucitron",
                "highPrivacy": true,
                "orientation": "top",
                "showIcon": false,
                "adblocker": false,
                "showAlertSmall": false,
                "cookieslist": true,
                "removeCredit": true,
                "bodyPosition": "top",
            });
            </script>';
        }
        
        if (defined('_CIWIDGET_RGPD_BANNIERE_SUR_TOUTES_LES_PAGES') AND _CIWIDGET_RGPD_BANNIERE_SUR_TOUTES_LES_PAGES=='oui'){
            if ($tableau_widgets_tarteaucitron){
                $flux .= '<script type="text/javascript">';
                foreach ($tableau_widgets_tarteaucitron as $type_widget) {
                    $flux .= "(tarteaucitron.job = tarteaucitron.job || []).push('".ciwidget_service_tarteaucitron($type_widget)."');";
                }
                $flux .= '</script>';
            }
        }
        
	return $flux;
}

function ciwidget_affichage_final($texte) {
    return ciwidget_affichage_final_desactiver($texte);
}

function ciwidget_affichage_final_prive($texte) {
    return ciwidget_affichage_final_desactiver($texte);
}

function ciwidget_affichage_final_desactiver($texte) {
    
    // desactivation (immédiate) forcée par constante des widgets concernés par le RGPD
    if (defined('_CIWIDGET_DESACTIVE_TOUS_WIDGETS_RGPD') AND _CIWIDGET_DESACTIVE_TOUS_WIDGETS_RGPD=='oui'){
        $tableau_widgets_tarteaucitron = ciwidget_tableau_widgets_tarteaucitron();
        
        $texte = str_replace('src="https://platform.twitter.com/widgets.js', 'class="', $texte);
        $type_widget = 'tweet';
        if (in_array($type_widget,$tableau_widgets_tarteaucitron)){
            $texte = str_replace("(tarteaucitron.job = tarteaucitron.job || []).push('".ciwidget_service_tarteaucitron($type_widget)."');", "", $texte);
        }
        $type_widget = 'twitter';
        if (in_array($type_widget,$tableau_widgets_tarteaucitron)){
            $texte = str_replace("(tarteaucitron.job = tarteaucitron.job || []).push('".ciwidget_service_tarteaucitron($type_widget)."');", "", $texte);
        }

        $type_widget = 'dailymotion';
        $texte = str_replace('src="https://www.dailymotion.com/embed/video/', 'class="', $texte);
        if (in_array($type_widget,$tableau_widgets_tarteaucitron)){
            $texte = str_replace("(tarteaucitron.job = tarteaucitron.job || []).push('".ciwidget_service_tarteaucitron($type_widget)."');", "", $texte);
        }

        $type_widget = 'youtube';
        $texte = str_replace('src="https://www.youtube-nocookie.com/embed/', 'class="', $texte);
        $texte = str_replace('src="https://www.youtube.com/embed/', 'class="', $texte);
        if (in_array($type_widget,$tableau_widgets_tarteaucitron)){
            $texte = str_replace("(tarteaucitron.job = tarteaucitron.job || []).push('".ciwidget_service_tarteaucitron($type_widget)."');", "", $texte);
        }

        $type_widget = 'slideshare';
        $texte = str_replace('src="https://www.slideshare.net/slideshow/embed_code/', 'class="', $texte);
        if (in_array($type_widget,$tableau_widgets_tarteaucitron)){
            $texte = str_replace("(tarteaucitron.job = tarteaucitron.job || []).push('".ciwidget_service_tarteaucitron($type_widget)."');", "", $texte);
        }

        $type_widget = 'linkedin';
        $texte = str_replace('src="https://www.linkedin.com/embed/', 'class="', $texte);
        if (in_array($type_widget,$tableau_widgets_tarteaucitron)){
            $texte = str_replace("(tarteaucitron.job = tarteaucitron.job || []).push('".ciwidget_service_tarteaucitron($type_widget)."');", "", $texte);
        }
    }
    
    return $texte;
}


/**
 * Ajouter le bouton d'ajout de widget sur les fiches objet
 *
 * Uniquement sur les objets pour lesquelles ils sont prévus
 *
 * @pipeline afficher_complement_objet
 * @param array $flux
 * @return array
 */
function ciwidget_afficher_complement_objet($flux) {
	if ($type = $flux['args']['type']
		and $id = intval($flux['args']['id'])
                and in_array($type, array('article','rubrique'))
		and (autoriser('modifier', $type, $id))
	) {
                // portfolio des widgets attaches
        	$contexte = array('objet' => $type, 'id_objet' => $id);
                $texte = recuperer_fond('prive/objets/contenu/portfolio_widget', array_merge($_GET, $contexte));
                
            
                $url = generer_url_ecrire('popin-ciwidget_type_widget','objet='.$type.'&id_objet='.$id);
                $url_ajax = generer_url_ecrire('popin-ciwidget_type_widget','var_zajax=contenu&objet='.$type.'&id_objet='.$id);

                $javascript = 'onclick="jQuery.modalboxload(\''.$url_ajax.'\',{autoResize: true});return false;"';
                $chemin_icone = find_in_path('prive/themes/spip/images/ciwidget-new-24.png');
                $libelle = _T('ciwidget:ajouter_widget');
                
                $texte .= '<div><span class="icone s24 verticale right ajax ciwidget-new-24">
                <a href="'.$url.'" title="Ajouter un widget" '.$javascript.'>
                <img src="'.$chemin_icone.'" alt="'.$libelle.'" width="24" height="24">
                <b>'.$libelle.'</b>
                </a></span></div>';
                
                
                $flux['data'] .= $texte;
	}

	return $flux;
}


function ciwidget_affiche_gauche($flux) {
	if ($en_cours = trouver_objet_exec($flux['args']['exec'])
		and $en_cours['edition'] !== false // page edition uniquement
		and $type = $en_cours['type']
		and $id_table_objet = $en_cours['id_table_objet']
		// id non defini sur les formulaires de nouveaux objets
		and (isset($flux['args'][$id_table_objet]) and $id = intval($flux['args'][$id_table_objet]))
	) {
		$flux['data'] .= recuperer_fond(
			'prive/objets/editer/colonne_widget',
			array('objet' => $type, 'id_objet' => $id)
		);
	}
        // compatibilite avec le plugin edition_directe
        elseif (defined('_DIR_PLUGIN_EDITION_DIRECTE')){
            include_spip('edition_directe_fonctions');

            $objets_edition_directe = array_intersect(objets_edition_directe(),array('article','rubrique'));
            if ($en_cours = trouver_objet_exec($flux['args']['exec']) and $type = $en_cours['type'] and in_array($type, $objets_edition_directe) and $id_table_objet = $en_cours['id_table_objet'] and ($id = intval($flux['args'][$id_table_objet]) or $id = 0 - $GLOBALS['visiteur_session']['id_auteur']) and autoriser('joindredocument', $type, $id)) {

                    if ($id > 0)
                            $flux['data'] .= recuperer_fond('prive/objets/editer/colonne_widget', array (
                                    'objet' => $type,
                                    'id_objet' => $id
                            ));
            }
        }
        
	return $flux;
}

function ciwidget_post_edition($flux) {
	$serveur = (isset($flux['args']['serveur']) ? $flux['args']['serveur'] : '');
	// si on institue un objet, mettre ses widgets lies a jour
	if (isset($flux['args']['table']) and $flux['args']['table'] !== 'spip_ciwidget') {
		$type = isset($flux['args']['type']) ? $flux['args']['type'] : objet_type($flux['args']['table']);
		// verifier d'abord les doublons !
                $table_objet = isset($flux['args']['table_objet']) ?
                        $flux['args']['table_objet'] : table_objet($flux['args']['table'], $serveur);
                
                $marquer_doublons_widget = charger_fonction('marquer_doublons_widget', 'inc');
                $marquer_doublons_widget($flux['data'], $flux['args']['id_objet'], $type, id_table_objet($type, $serveur),
                        $table_objet, $flux['args']['table'], '', $serveur);

	} else {
		if (isset($flux['args']['table']) and $flux['args']['table'] !== 'spip_ciwidget') {
			// verifier les doublons !
			$marquer_doublons_widget = charger_fonction('marquer_doublons_widget', 'inc');
			$marquer_doublons_widget($flux['data'], $flux['args']['id_objet'], $flux['args']['type'],
				id_table_objet($flux['args']['type'], $serveur), $flux['args']['table_objet'],
				$flux['args']['spip_table_objet'], '', $serveur);
		}
	}

	return $flux;
}


/**
 * Avant l'enregistrement d'un article (ou d'une rubrique, ...) verifier que les raccourcis <widget...>, etc
 * qu'il contient ne sont pas ceux d'un autre article (ou d'une rubrique, ...)
 *
 * @param array $flux
 * @return array
 */
function ciwidget_pre_edition($flux){
    $champs = array();	
    if ($flux['args']['table']=='spip_articles'){
                $champs = array('surtitre', 'titre', 'soustitre', 'descriptif', 'nom_site', 'url_site', 'chapo', 'texte', 'ps');
    } elseif ($flux['args']['table']=='spip_rubriques'){
                $champs = array('titre', 'texte', 'descriptif');
    }
    if ($champs) {
                foreach ($champs as $champ) {
                    if (isset($flux['data'][$champ]) AND $flux['data'][$champ]){
                        $flux['data'][$champ] = ciwidget_anti_scan_widget($flux['data'][$champ],$flux['args']['table'],$flux['args']['id_objet'],$champ);
                    }
                }
    }

    return $flux;
}


/**
 * Anti scan de document via <doc...>, etc
 *
 * @param string $texte
 * @return string
 */
function ciwidget_anti_scan_widget($texte,$table='',$id_objet='',$champ=''){
	// contourner le cas d'un double appel du pipeline sur la meme table
	static $tableau = array();
        
        $id = $table.$id_objet.$champ;
        
        $ok = true;
        // exception pour CISF
        if (isset($_POST['cisf_nostatic']) AND $_POST['cisf_nostatic'] == "oui")
            $ok = false;
        
	if ($id){
		if ($tableau AND isset($tableau[$id]) AND $ok){
			return $tableau[$id];
		} else {
                        if (!empty($texte) AND strpos($texte, "<widget_") !== false) {
                                if (preg_match_all(',<widget_([a-z]+)([0-9]+)(\|([^>]*))?'.'\s*/?'.'>,i', $texte, $matches, PREG_SET_ORDER)) {
                                        foreach ($matches as $match) {
                                                $raccourci = $match[0];
                                                $id_widget = intval($match[2]);
                                                $type_widget = $match[1];
                                                $objet = substr($table,5,-1);
                                                $where = "id_widget=".intval($id_widget)." AND type_widget='".$type_widget."' AND objet='".$objet."' AND id_objet=".intval($id_objet);
                                                if (!sql_countsel("spip_ciwidget", $where)){
                                                        $texte = str_replace($raccourci,'',$texte);
                                                }
                                        }
                                }
                        }
			$tableau[$id] = $texte;
		}
	}

	return $texte;
}


function ciwidget_optimiser_base_disparus($n){
        $widgets = array();
        $documents = array();

        // Attention : Il faut memoriser les documents concernes
        // avant que la fonction lien_optimise de SPIP ne supprime les liaisons 
        
        // widget(s) des articles supprimes
	$res = sql_select("lien.id_widget AS widget",
	 	        "spip_ciwidget AS lien
		        LEFT JOIN spip_articles AS articles
		          ON (lien.id_objet=articles.id_article AND lien.objet='article')",
			"lien.objet='article' AND articles.id_article IS NULL");

        while ($row = sql_fetch($res)){
           $widgets[] = $row['widget'];
        }

        // widget(s) des rubriques supprimees
	$res = sql_select("lien.id_widget AS widget",
	 	        "spip_ciwidget AS lien
		        LEFT JOIN spip_rubriques AS rubriques
		          ON (lien.id_objet=rubriques.id_rubrique AND lien.objet='rubrique')",
			"lien.objet='rubrique' AND rubriques.id_rubrique IS NULL");

        while ($row = sql_fetch($res)){
           $widgets[] = $row['widget'];
        }
        
        // document(s) des widget(s) supprimes
	$res = sql_select("L.id_document AS document",
	 	        "spip_documents_liens AS L
		         LEFT JOIN spip_ciwidget AS A
		         ON (L.id_objet=A.id_widget AND L.objet='ciwidget')",
			"L.objet='ciwidget' AND ".sql_in("L.id_objet",$widgets));

        while ($row = sql_fetch($res)){
           $documents[] = $row['document'];
        }
        
        // supprimer les widgets
	sql_delete("spip_ciwidget", sql_in("id_widget", $widgets));
        
        // dissocier les documents de ces widgets
        sql_delete("spip_documents_liens", sql_in("id_document",$documents)." AND objet='ciwidget'");

        // puis on supprime les document(s) des widget(s) supprimes
        foreach($documents AS $id_document){
                ciwidget_supprimer_document($id_document);
        }

    return $n;
}

function ciwidget_supprimer_document($id_document) {

	include_spip('inc/documents');
	if (!$doc = sql_fetsel('*', 'spip_documents', 'id_document='.$id_document))
		return false;

	spip_log("Suppression du document $id_document (".$doc['fichier'].")");

	// Si c'est un document ayant une vignette, supprimer aussi la vignette
	if ($doc['id_vignette']) {
		ciwidget_supprimer_document($doc['id_vignette']);
		sql_delete('spip_documents_liens', 'id_document='.$doc['id_vignette']);
	}

	// Supprimer le fichier si le doc est local,
	// et la copie locale si le doc est distant
	if ($doc['distant'] == 'oui') {
		include_spip('inc/distant');
		if ($local = copie_locale($doc['fichier'],'test'))
			spip_unlink($local);
	}
	else spip_unlink(get_spip_doc($doc['fichier']));

	sql_delete('spip_documents', 'id_document='.$id_document);

	if (defined('_DIR_PLUGIN_CITRACE')){
		$message = '('.$doc['fichier'].')';	
		if ($citrace = charger_fonction('citrace', 'inc'))
			$citrace('document', $id_document, 'supprimer document', $message);
	}	
	
	return true;
}


function ciwidget_formulaires_avec_bigup() {
    return array(
            'ciwidget_video',
            'ciwidget_illustrer_document',
            'ciwidget_infographie',
            'ciwidget_audio',
            'ciwidget_illustrer_widget'
        );
}

function ciwidget_medias_formulaire_fond($flux) {

    $ci_formulaires_avec_bigup = ciwidget_formulaires_avec_bigup();
    
    if (defined('_DIR_PLUGIN_BIGUP')
        AND isset($flux['args']['form'])
        AND in_array($flux['args']['form'], $ci_formulaires_avec_bigup)){

      	if (test_espace_prive() 
          OR ($cipage = _request('page') AND $cipage AND strlen($cipage)>=5 AND substr($cipage,0,5)=='cisf_')
          ) {
            if (ciwidget_utiliser_bigup()){ 
                $bigup = bigup_get_bigup(['args' => $flux['args']['contexte']]);
                $formulaire = $bigup->formulaire($flux['data'], $flux['args']['contexte']);

                $formulaire = ciwidget_medias_formulaire_ciwidget($flux['args'], $formulaire);

                $flux['data'] = $formulaire->get();
            }
      	}
    }

    return $flux;
}

function ciwidget_medias_formulaire_ciwidget($args, $formulaire) {

    $options = 	array(
			'multiple' => false,
			'previsualiser' => true
		);
    
    if (isset($args['form']) AND in_array($args['form'], array('ciwidget_illustrer_document','ciwidget_illustrer_widget'))){
	$options['accept'] = bigup_get_accept_logos();
    }
    
    $formulaire->preparer_input('fichier_upload[]', $options);
    
    return $formulaire;
}

?>