<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

include_spip('inc/widget_commun');

function formulaires_ciwidget_galerie_charger_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
	if (!autoriser('modifier',$objet,$id_objet))
		return false;

        $ci_type_galerie_defaut = ciwidget_lire_meta_cle('galerie','type_galerie_defaut');
        $valeurs = array('objet'=>$objet,'id_objet'=>$id_objet,'afficher_certaines_images'=>'non','liste_images'=>'','type_galerie'=>$ci_type_galerie_defaut,'imposer_type_galerie'=>'non');
        $images_selected = array();

        $id_widget = intval($id_widget);
	if ($id_widget>0) {
		$result = sql_select("*", "spip_ciwidget", "id_widget=$id_widget");
		while ($row = sql_fetch($result)) { 
			$valeurs = $row;
		}
        
                // anti hack
                if (isset($valeurs['type_widget']) AND $valeurs['type_widget']!='galerie'){
                    return false;
                }
                
                // unserialize le champ contenu
                if (isset($valeurs['contenu'])){
                    $contenu = unserialize($valeurs['contenu']);
                    $valeurs['contenu'] = '';
                    if ($contenu AND is_array($contenu)){
                        $valeurs = array_merge($valeurs,$contenu);
                    }
                }
                if (isset($valeurs['liste_images'])){
                    $images_selected = explode(",", $valeurs['liste_images']);
                }
	}
        
        $valeurs['images_selected'] = $images_selected;
        
        $ci_imposer_type_galerie = ciwidget_lire_meta_cle('galerie','imposer_type_galerie');

        if ($ci_imposer_type_galerie=='oui' AND $ci_type_galerie_defaut){
            $valeurs['imposer_type_galerie'] = $ci_imposer_type_galerie;
            $valeurs['type_galerie'] = $ci_type_galerie_defaut;
        }
        
        if (!isset($valeurs['tri_galerie'])){
            $valeurs['tri_galerie'] = 'rang_lien';
        }
        
        $valeurs['retour_objet'] = ciwidget_retour_vers_objet($objet, $id_objet);

	return $valeurs;
}

function formulaires_ciwidget_galerie_verifier_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
        $erreurs = array();
        
      	$titre = _request('titre');	
      	if (!$titre){
      		$erreurs['titre'] = _T('info_obligatoire');
        }

        $tri_galerie = _request('tri_galerie');
        if (!in_array($tri_galerie, array('rang_lien','titre','fichier','id_document'))){
      		$erreurs['tri_galerie'] = _T('ciwidget:valeur_incorrecte');
        }

        $afficher_certaines_images = _request('afficher_certaines_images');
        if (!in_array($afficher_certaines_images, array('oui','non'))){
      		$erreurs['afficher_certaines_images'] = _T('ciwidget:valeur_incorrecte');
        }
        
        $liste_images = _request('liste_images');
        if ($liste_images AND !is_array($liste_images)){
		      $erreurs['liste_images'] = _T('ciwidget:valeur_incorrecte');
        }

        $ci_imposer_type_galerie = ciwidget_lire_meta_cle('galerie','imposer_type_galerie');
        if ($ci_imposer_type_galerie!='oui'){
            $type_galerie = _request('type_galerie');
            if (!in_array($type_galerie, array('vignette','point','normal'))){
                    $erreurs['type_galerie'] = _T('ciwidget:valeur_incorrecte');
            }
        }
        
	return $erreurs;
}

function formulaires_ciwidget_galerie_traiter_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
        $id_widget = intval($id_widget);
        $images_avant = explode(',',ciwidget_lire_meta_cle('galerie','liste_images'));
        $afficher_certaines_images_avant = ciwidget_lire_meta_cle('galerie','afficher_certaines_images');

        $c = array();
      	foreach (array('titre') as $champ){
      		$c[$champ] = _request($champ);
        }
        
        $tri_galerie = _request('tri_galerie');
        $afficher_certaines_images = _request('afficher_certaines_images');
        $images = _request('images');
        $liste_images = '';
        if ($images AND is_array($images)){
            $liste_images = implode(",", $images);
        }
        
        $ci_imposer_type_galerie = ciwidget_lire_meta_cle('galerie','imposer_type_galerie');
        if ($ci_imposer_type_galerie!='oui'){
            $type_galerie = _request('type_galerie');
        } else {
            $type_galerie = ciwidget_lire_meta_cle('galerie','type_galerie_defaut');
        }
        
        $type_widget = 'galerie';
        $c['contenu'] = serialize(array('tri_galerie'=>$tri_galerie,'afficher_certaines_images'=>$afficher_certaines_images,'liste_images'=>$liste_images,'type_galerie'=>$type_galerie));
        $c['type_widget'] = $type_widget;
        $c['objet'] = $objet;
        $c['id_objet'] = $id_objet;

      	if ($id_widget>0) {
            // modifier
            sql_updateq("spip_ciwidget", $c, "id_widget=$id_widget");
        } else {
            // ajouter et lier
            $id_widget = sql_insertq('spip_ciwidget', $c);
        }
    
        $res = ciwidget_retour_formulaire($objet,$id_objet,$type_widget,$retour);

	return $res;
}

?>