<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

include_spip('inc/widget_commun');
include_spip('inc/ciwidget_tmp');
include_spip('inc/ciwidget_graphique');
include_spip('inc/joindre_document');
include_spip('inc/documents');
include_spip('inc/ciwidget_importer');


function formulaires_ciwidget_tableau4_charger_dist($objet = '', $id_objet = '', $id_widget = 0, $id_widget_tmp = 0, $retour = '') {
    
	if (!$id_widget_tmp){
		return false;
        }
        
        $valeurs = ciwidget_valeurs_tmp($id_widget,$id_widget_tmp,'tableau');
        
        // securite
	if (!isset($valeurs['objet']) OR !isset($valeurs['id_objet']) OR !isset($valeurs['id_auteur']) 
                OR !autoriser('modifier',$valeurs['objet'],$valeurs['id_objet'])
                OR $valeurs['id_auteur']!=$GLOBALS['visiteur_session']['id_auteur']){
		return false;
        }

        $valeurs['retour_objet'] = ciwidget_retour_tmp_vers_objet($id_widget_tmp,$objet,$id_objet,$valeurs);
        
	return $valeurs;
}

function formulaires_ciwidget_tableau4_verifier_dist($objet = '', $id_objet = '', $id_widget = 0, $id_widget_tmp = 0, $retour = '') {
        $erreurs = array();
        
        if (isset($_POST['suivant'])){
            $tmp_file = $_FILES['fichier_upload']['tmp_name'];
            $file_name = $_FILES['fichier_upload']['name'];

            if (isset($tmp_file['error'])
                    and $test = joindre_upload_error($tmp_file['error'])
            ) {
                if (is_string($test)) {
                        $erreurs['fichier_upload'] = $test;
                } else {
                        $erreurs['fichier_upload'] = _T('medias:erreur_aucun_fichier');
                }
            }
            
            if (!is_uploaded_file($tmp_file)){
		$erreurs['fichier_upload'] = _T('medias:erreur_aucun_fichier');
            }

            if (preg_match('#[\x00-\x1F\x7F-\x9F/\\\\]#', $file_name)){
              	$erreurs['fichier_upload'] = _T('medias:erreur_upload_type_interdit');
            }
        
            if (preg_match(',\.([a-z0-9]+)(\?.*)?$,i', $file_name, $match) and $ext = $match[1]){
                if (!in_array(strtolower($ext),array('csv','xlsx')) ) {
                    $erreurs['fichier_upload'] = _T('medias:erreur_upload_type_interdit');
                }
            } else {
              	$erreurs['fichier_upload'] = _T('medias:erreur_upload_type_interdit');
            }
        } else {
            $erreurs['fichier_upload'] = _T('medias:erreur_aucun_fichier');
        }
        
	return $erreurs;
}

function formulaires_ciwidget_tableau4_traiter_dist($objet = '', $id_objet = '', $id_widget = 0, $id_widget_tmp = 0, $retour = '') {
        refuser_traiter_formulaire_ajax();    
    
        $type_widget = 'tableau';
        $c = array();
        $contenu_nouveau = array();
        $erreur = '';

        $tmp_file = $_FILES['fichier_upload']['tmp_name'];
        $file_name = $_FILES['fichier_upload']['name'];
        preg_match(',\.([a-z0-9]+)(\?.*)?$,i', $file_name, $match);
        $ext = strtolower($match[1]);
        $destination = sous_repertoire(_DIR_CACHE, 'export').$file_name;
        
        $ok = deplacer_fichier_upload($tmp_file, $destination);

        if ($ext=='xlsx'){
            $c['donnees'] = ciwidget_lire_xlsx($destination,'',false);
            
        } elseif ($ext=='csv'){
            $c['donnees'] = ciwidget_lire_csv($destination,'',false);
        }
        
        $id_widget_tmp = ciwidget_maj_tmp($id_widget,$id_widget_tmp,$c,$contenu_nouveau);

        unlink($destination);
        
        $res = ciwidget_retour_formulaire_etape($objet,$id_objet,$id_widget,$id_widget_tmp,$type_widget,3);

	return $res;
}

?>