<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}


/**
 * Récupérer les données via l'API de Dailymotion
 */
function ciwidget_api_dailymotion_recuperer_data($id_dailymotion='') {
	static $cache = array();
        
	if (!$id_dailymotion OR !ctype_alnum($id_dailymotion)) {
		return false;
	}
        
        
        $data_url = 'https://api.dailymotion.com/video/'.$id_dailymotion.'?fields=id,title,tag,duration,description,owner,owner.screenname,owner.url';
        
	if (isset($cache[$data_url])) {
		return $cache[$data_url];
	}

	// on recupere le contenu de la page
        spip_log('Requete (recuperer_page) pour API Dailymotion : '.$data_url, _LOG_DEBUG);
        include_spip('inc/distant');
	if (spip_version()>=4) {
            $data = recuperer_url($data_url);
            if ($data AND isset($data['page'])){
                $data = $data['page'];
            } else {
                $data = '';
            }
        } else {
            $data = recuperer_page($data_url);
        }
        
	if (!$data) {
                spip_log('ECHEC requete (recuperer_page) pour API Dailymotion : '.$data_url, _LOG_ERREUR);
	} else {
		spip_log('Infos brutes pour API Dailymotion '.$data_url.' : '.$data, _LOG_DEBUG);
	}

	if ($data) {
                $data = json_decode($data, true);
                $data['data_url'] = $data_url;
                $cache[$data_url] = $data;
	}
        
	return $cache[$data_url];
}

?>