<?php
/**
 * Plugin CIWIDGET 
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined("_ECRIRE_INC_VERSION")) return;


/*
 * Invalider le cache correspondant
 */
function ciwidget_invalider_cache($id_objet,$objet,$url_objet=''){
    $return = '';
    $id_objet = intval($id_objet);
    
    if ($id_objet AND $objet){
        include_spip('inc/utils');
        include_spip('public/assembler');
        include_spip('public/cacher');
        include_spip('inc/flock');

        // url
        if ($url_objet){
            // le host est fictif car pas utilise mais est utile pour parse_url
            $url_public = "http://test.fr".$url_objet;
            
            // securite
            include_spip('inc/ciwidget_verifier');
            if (!ciwidget_verifier_url_absolue($url_public)){
                return $return;
            }
        } else {
            // solution de secours
            $url_public = generer_url_entite_absolue($id_objet, $objet, '', '', true);
        }
        
        // contexte
        $contexte = ciwidget_contexte_import($url_public);
        
        // contexte_implicite
        $page = array('contexte_implicite' => calculer_contexte_implicite());
        
	if (!defined('_SPIP_PAGE')) {
            /** Argument page, personalisable en cas de conflit avec un autre script */
            define('_SPIP_PAGE', 'page');
	}
        if (isset($contexte[_SPIP_PAGE])){
            $page['contexte_implicite']['cache'] = $contexte[_SPIP_PAGE];
        }
	$parts = parse_url($url_public);
        if (!empty($parts['path'])){
            $page['contexte_implicite']['cache'] .= preg_replace(
                    ',\.[a-zA-Z0-9]*$,',
                    '',
                    preg_replace('/[?].*$/', '', $parts['path'])
            );
        }
        
        // chemin du fichier cache
        $chemin_cache = cache_chemin_fichier(generer_nom_fichier_cache($contexte, $page));
        
        // supprimer
        supprimer_fichier($chemin_cache);
    }
    
    return $return;
}

/*
 * Determiner le contexte en fonction de l'URL
 */
function ciwidget_contexte_import($url_public){
    $contexte = array();

    if ($url_public){
        if (!defined('_CONTEXTE_IGNORE_VARIABLES')) {
                define('_CONTEXTE_IGNORE_VARIABLES', '/(^var_|^PHPSESSID$|^fbclid$|^utm_)/');
        }
        
        // determiner le contexte en fonction de l'URL
	$parts = parse_url($url_public);
        if (!empty($parts['query'])){
            $query = html_entity_decode($parts['query']);
            $tableau = array();
            parse_str($query, $tableau);            
            if ($tableau){
                foreach ($tableau as $var=>$val) {
                    if (!preg_match(_CONTEXTE_IGNORE_VARIABLES, $var)) {
                            $contexte[$var] = $val;
                    }
                }
            }
        }
    }

    // simuler l'ecran de securite qui utilise intval
    if ($contexte){
        $_exceptions = array('id_table', 'id_base', 'id_parent', 'id_article_pdf');
        foreach ($contexte as $var => $val) {
            if ($val AND strncmp($var, "id_", 3) == 0 AND !in_array($var, $_exceptions)) {
                    $contexte[$var] = is_array($val) ? @array_map('intval', $val) : intval($val);
            }
        }
    }
    
    return $contexte;
}

?>