<?php
/**
 * Plugin ciwidget
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined("_ECRIRE_INC_VERSION")) return;



// Appel generique
function ciwidget_verifier($champ,$texte){
    if (empty($champ)){
        return false;
    }
    
    if (ctype_alnum(str_replace('_','',$champ)) AND function_exists($f = 'ciwidget_verifier_' . $champ)) {
            return $f($texte);
    } elseif (ctype_alnum(str_replace('_','',$champ)) AND substr($champ,0,7)=='statut_' AND function_exists($f = 'ciwidget_verifier_statut')) {
            return $f($texte);
    } elseif (ctype_alnum(str_replace('_','',$champ)) AND substr($champ,0,5)=='rgpd_' AND function_exists($f = 'ciwidget_verifier_rgpd')) {
            return $f($texte);
    } else {
            return false;
    }
}

function ciwidget_verifier_tableau_du_graphique($texte=''){
    return ciwidget_verifier_oui_non($texte);
}

function ciwidget_verifier_largeur_non_modifiable($texte=''){
    return ciwidget_verifier_oui_non($texte);
}

function ciwidget_verifier_imposer_ratio_comme_maximum($texte=''){
    return ciwidget_verifier_oui_non($texte);
}

function ciwidget_verifier_hauteur_non_modifiable($texte=''){
    return ciwidget_verifier_oui_non($texte);
}

function ciwidget_verifier_hauteur_defaut($texte=''){
    return ciwidget_verifier_entier($texte);
}

function ciwidget_verifier_largeur_defaut($texte=''){
    return ciwidget_verifier_entier($texte);
}

function ciwidget_verifier_tarteaucitron($texte=''){
    return ciwidget_verifier_oui_non($texte);
}

function ciwidget_verifier_rgpd($texte=''){
    return ciwidget_verifier_oui_non($texte);
}

function ciwidget_verifier_api_dailymotion($texte=''){
    return ciwidget_verifier_oui_non($texte);
}

function ciwidget_verifier_statut($texte=''){
    $return = false;    
    if (in_array($texte, array('active','masque','desactive','defaut'))){
            $return = true;
    }
    return $return;
}

function ciwidget_verifier_largeur_min($texte=''){
    return ciwidget_verifier_entier($texte);
}

function ciwidget_verifier_largeur_max($texte=''){
    return ciwidget_verifier_entier($texte);
}

function ciwidget_verifier_playlist_defaut($texte=''){
    $return = false;
    
    if (!$texte OR ctype_alnum($texte)){
        $return = true;
    }
    
    return $return;
}

function ciwidget_verifier_hauteur_min($texte=''){
    return ciwidget_verifier_entier($texte);
}

function ciwidget_verifier_hauteur_max($texte=''){
    return ciwidget_verifier_entier($texte);
}

function ciwidget_verifier_debit_video_max($texte=''){
    return ciwidget_verifier_entier($texte);
}

function ciwidget_verifier_video_num_skin($texte=''){
    $return = false;    
    if (in_array($texte, array('1','2','3'))){
            $return = true;
    }
    return $return;
}

function ciwidget_verifier_mp4($texte=''){
    return ciwidget_verifier_oui_non($texte);
}

function ciwidget_verifier_webm($texte=''){
    return ciwidget_verifier_oui_non($texte);
}

function ciwidget_verifier_ogv($texte=''){
    return ciwidget_verifier_oui_non($texte);
}

function ciwidget_verifier_mp3($texte=''){
    return ciwidget_verifier_oui_non($texte);
}

function ciwidget_verifier_wav($texte=''){
    return ciwidget_verifier_oui_non($texte);
}

function ciwidget_verifier_ogg($texte=''){
    return ciwidget_verifier_oui_non($texte);
}

function ciwidget_verifier_nb_article_defaut($texte=''){
    return ciwidget_verifier_entier($texte);
}

function ciwidget_verifier_affiche_descriptif_defaut($texte=''){
    return ciwidget_verifier_oui_non($texte);
}

function ciwidget_verifier_affiche_date_article_defaut($texte=''){
    return ciwidget_verifier_oui_non($texte);
}

function ciwidget_verifier_forme($texte=''){
    $return = false;
    if (ctype_alnum(str_replace('_','',$texte)) AND substr($texte,0,5)=='forme'){
        $return = true;
    }
    return $return;
}

function ciwidget_verifier_imposer_alignement_widget($texte=''){
    $return = false;
    if (in_array($texte,array('non','left','center','right'))){
        $return = true;
    }
    return $return;
}

function ciwidget_verifier_utilisersurtitre($texte=''){
    $return = false;
    if (in_array($texte,array('oui','non','impose'))){
        $return = true;
    }
    return $return;
}

function ciwidget_verifier_oui_non($texte=''){
    $return = false;
    
    if ($texte AND in_array($texte, array('oui','non'))){
            $return = true;
    }

    return $return;
}

function ciwidget_verifier_true_false($texte=''){
    $return = false;
    
    if ($texte AND in_array($texte, array('true','false'))){
            $return = true;
    }

    return $return;
}

function ciwidget_verifier_entier($texte){
    $return = false;
    
    if (!$texte OR ctype_digit($texte)){
        $return = true;
    }
    
    return $return;
}

function ciwidget_verifier_float($texte){
    $return = false;
    
    if (!$texte OR is_numeric($texte)){
        $return = true;
    }
    
    return $return;
}

function ciwidget_verifier_pourcentage($texte=''){
    $return = false;
    $resultat = intval($texte);
    if ($resultat>=1 AND $resultat<=100){
        $return = true;
    }
    return $return;
}

function ciwidget_verifier_couleur_hexa($couleur){
    $return = false;
    
    if (preg_match(',^#[a-f0-9]{6}$,i', $couleur)){
        $return = true;
    }
    
    return $return;
}

// Appel generique
function ciwidget_verifier_tableau($champ,$tableau,$type_et_id='',$log=false){
    
    if (ctype_alnum(str_replace('_','',$champ)) AND function_exists($f = 'ciwidget_verifier_tableau_' . $champ)) {
            return $f($tableau,$type_et_id,$log);
    } else {
            return false;
    }
}

// cistyle couleur
function ciwidget_verifier_tableau_couleur($tableau=array(),$type_et_id='',$log=false){
    include_spip('inc/cistyle_commun');    
    $return = true;

    // tableau des couleurs
    $tableau_nom_des_couleurs = cistyle_tableau_nom_des_couleurs();

    foreach ($tableau AS $cle=>$valeur){
        if (!in_array($cle, $tableau_nom_des_couleurs)
            OR (!cistyle_verifier_couleur_hexa($valeur))){
            $return = false;
            break;
        }
    }
    
    if (!$return AND $log)
        spip_log("ciwidget definition ".$type_et_id." : couleurs de la palette incorrectes",_LOG_ERREUR);
    
    return $return;
}

// cistyle palette (exception : ce n'est pas un tableau)
function ciwidget_verifier_tableau_palette($tableau='',$type_et_id='',$log=false){
    include_spip('inc/cistyle_commun');
    $return = false;
    
    $palette = intval($tableau);
    if ($palette>0 AND $palette<=count(cistyle_tableau_couleurs_palettes())+1) {
        $return = true;
    }
    
    if (!$return AND $log)
        spip_log("ciwidget definition ".$type_et_id." : numero de palette incorrect",_LOG_ERREUR);
    
    return $return;
}

function ciwidget_verifier_url_absolue($url){
    $return = false;
    
    // Enlever les caracteres illegaux
    $safe_url = filter_var($url, FILTER_SANITIZE_URL);
    
    if ($safe_url == $url) {
        // Verifier l'url
        if (!filter_var($safe_url, FILTER_VALIDATE_URL) === false)
            $return = true;
    }
    return $return;
}

function ciwidget_verifier_url_relative($url_relative=''){
    $return = false;
    $suspect = false;

    if (tester_url_absolue($url_relative)){
        return $return;
    }
    
    if ($url_relative){
        // eviter des URL malicieuses
        $parties_url_suspectes = array("../../",".././","./../");
        foreach ($parties_url_suspectes as $partie_url_suspecte){
            if (strpos($url_relative, $partie_url_suspecte) !== false){
                $suspect = true;
                break;
            }
        }
        
        if (!$suspect){
            if (substr($url_relative,0,1)!='/'){
                $url_relative = '/' . $url_relative;
            }
            // le host est fictif car pas utilise mais est utile pour parse_url
            $url_absolue = "http://test.fr".$url_relative;
            $return = ciwidget_verifier_url_absolue($url_absolue);
        }
    } else {
        $return = true;
    }
    return $return;
}

function ciwidget_verifier_url_absolue_ou_relative($url=''){
    $return = false;
    
    if (tester_url_absolue($url)){
        if (ciwidget_verifier_url_absolue($url)){
            $return = true;
        }
    } else {
        if (ciwidget_verifier_url_relative($url)) {
            $return = true;
        } 
    }
    return $return;
}

function ciwidget_verifier_niveau_titre($texte){
    $return = false;
    
    if (in_array($texte,array('p','h2','h3','h4','h5','h6'))){
        $return = true;
    }
    return $return;
}

function ciwidget_verifier_titre_niveau_titre($texte){
    return ciwidget_verifier_niveau_titre($texte);
}

function ciwidget_verifier_surtitre_niveau_titre($texte){
    return ciwidget_verifier_niveau_titre($texte);
}

function ciwidget_verifier_nom_niveau_titre($texte){
    return ciwidget_verifier_niveau_titre($texte);
}

function ciwidget_verifier_titreitem_niveau_titre($texte){
    return ciwidget_verifier_niveau_titre($texte);
}

function ciwidget_verifier_masquer_bordure($texte=''){
    return ciwidget_verifier_oui_non($texte);
}

function ciwidget_verifier_limiter_hosts($texte){
    return ciwidget_verifier_oui_non($texte);
}

function ciwidget_verifier_hosts_liste($texte){
    return $texte;
}

function ciwidget_verifier_affichericone($texte=''){
    return ciwidget_verifier_oui_non($texte);
}

function ciwidget_verifier_espacevidesansvignette($texte=''){
    return ciwidget_verifier_oui_non($texte);
}

function ciwidget_verifier_ajoutquote($texte){
    $return = false;
    
    if (in_array($texte,array('aucun','quote1','quote2','quote3'))){
        $return = true;
    }
    return $return;
}

function ciwidget_verifier_type_galerie_defaut($texte){
    $return = false;
    
    if (in_array($texte,array('vignette','point','normal'))){
        $return = true;
    }
    return $return;
}

function ciwidget_verifier_imposer_type_galerie($texte=''){
    return ciwidget_verifier_oui_non($texte);
}

function ciwidget_verifier_afficher_image_en_grand($texte=''){
    return ciwidget_verifier_oui_non($texte);
}

?>