<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}


/* Fil d'information de Twitter */
function ci_twitter_url($url){
    $return = '';
    if (empty($url)){
        return '';
    }
    $url = trim($url);
    $tscs = '';

    // verifier l'URL
    if (substr($url, 0, 20)=='https://twitter.com/' AND strpos($url,'/status/')===false) {
        $tscs = substr($url, 20);
    } elseif (substr($url, 0, 14)=='https://x.com/' AND strpos($url,'/status/')===false) {
        $tscs = substr($url, 14);
        $url = str_replace('https://x.com/','https://twitter.com/',$url);
    }  
    
    if ($tscs){
        // enlever les parametres
        $tableau = explode('?',$tscs);
        $tscs = $tableau[0];
        // interdire les caracteres dangereux
        // limiter aux a-zA-Z0-9, aux underscores
        $tscs = str_replace("_",'',$tscs);
        if (ctype_alnum($tscs)) {
            $return = $url;
        }
    }    

    return $return;
}

function ci_twitter_user($url){
    $return = '';
    $url = ci_twitter_url($url);

    if ($url) {
        $pos = strrpos($url,'/');
        if ($pos>1){
            $return = substr($url,$pos+1);
        }
    }  

    return $return;
}


/* Tweet */

function ci_tweet_url($url){
    $return = '';
    if (empty($url)){
        return '';
    }
    $url = trim($url);
    $tscs = '';

    // verifier l'URL
    if (substr($url, 0, 20)=='https://twitter.com/' AND strpos($url,'/status/')!==false) {
        $tscs = substr($url, 20);
    } elseif (substr($url, 0, 14)=='https://x.com/' AND strpos($url,'/status/')!==false) {
        $tscs = substr($url, 14);
        $url = str_replace('https://x.com/','https://twitter.com/',$url);
    }
    
    if ($tscs){
        // interdire les caracteres dangereux
        // limiter aux a-zA-Z0-9, aux underscores et slash
        $tscs = str_replace(array("_","/"),'', $tscs);
        if (ctype_alnum($tscs)) {
            $return = $url;
        }
    }  

    return $return;
}

function ci_tweet_id($url){
    $return = '';
    $url = ci_tweet_url($url);

    if ($url) {
        $pos = strrpos($url,'/');
        if ($pos>1){
            $return = substr($url,$pos+1);
        }
    }  

    return $return;
}


/* Commun */

function ci_twitter_script($arg=''){
    static $done = false;
    static $firstarg = 0;
    $return = '';

    if (!$done OR $firstarg==$arg){
        $done = true;
        $firstarg = $arg;
        $return = '<script async src="https://platform.twitter.com/widgets.js" charset="utf-8"></script>';
    }
    
    return $return;
}


?>