<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

include_spip('inc/widget_commun');
include_spip('inc/texte');


function ciwidget_carte_gis($id_widget){
    $fond = 'modeles/carte_gis';
    $contexte = array();
    $widget = array();
    $objets = '';
    
    $id_widget = intval($id_widget);
    if (defined('_DIR_PLUGIN_GIS') AND $id_widget>0) {
            $widget = sql_fetsel("*", "spip_ciwidget", "id_widget=$id_widget");
            
            $objet = $widget['objet'];
            $id_objet = $widget['id_objet'];
            $titre = $widget['titre'];
            $descriptif = $widget['descriptif'];
            $contexte = unserialize($widget['contenu']);
            
            $contexte['id_map'] = $id_widget;
            $contexte['titre'] = texte_script(interdire_scripts(strip_tags($titre)));
            $contexte['description'] = texte_script(interdire_scripts(strip_tags($descriptif)));
            $contexte['objets'] = 'point_libre';
            $contexte['zoom_wheel'] = 'non';
            $contexte['fullscreen'] = 'oui';
            $contexte['scale'] = 'oui';
            
            if (isset($contexte['largeur'])){
                $contexte['largeur'] = $contexte['largeur'] . '%';
            }
            if (isset($contexte['hauteur'])){
                $contexte['hauteur'] = $contexte['hauteur'] . 'px';
            }

            if (isset($contexte['fondcarte'])){
                if ($contexte['fondcarte']=='photo'){
                    include_spip('inc/config');
                    $couches_proposees = lire_config('gis/layers');
                    if (in_array('google_satellite', $couches_proposees)){
                        $contexte['default_layer'] = 'google_satellite';
                    } elseif (in_array('esri_worldimagery', $couches_proposees)){
                        $contexte['default_layer'] = 'esri_worldimagery';
                    }
                } elseif ($contexte['fondcarte']=='choix'){
                    include_spip('inc/config');
                    $couches_proposees = lire_config('gis/layers');
                    $couche_defaut = gis_layer_defaut();
                    if (in_array($couche_defaut, $couches_proposees)){
                        $couche_defaut = '';
                    } else {
                        $couche_defaut .= '/';
                    }
                    $contexte['affiche_layers'] = $couche_defaut.implode('/',$couches_proposees);
                }
            }
            
            $tableau = ciwidget_gis_typecarte();
            
            if (isset($contexte['typecarte'])){
                $typecarte = $contexte['typecarte'];
                if ($typecarte=='point_libre'){
                        $contexte['objets'] = 'widget';
                        $contexte['id_widget'] = $id_widget;
                        $contexte['description'] = '';
                    
                } else {
                    if (isset($tableau[$typecarte])){
                        // objets au sens GIS
                        $objets = $tableau[$typecarte]['objets'];
                        $contexte['objets'] = $objets;

                        // numero le cas echeant
                        $id_critere = $tableau[$typecarte]['id_critere'];
                        $numero = $contexte['numero'];
                        if ($id_critere AND $numero){
                            $contexte[$id_critere] = $numero;
                        }

                        // cas particulier
                        if ($objets=='objet'){
                            if ($objet!='article'){
                                include_spip('base/objets');
                                $table_objet = table_objet($objet);
                                $id_table_objet = id_table_objet($objet);
                            } else {
                                $table_objet = 'articles';
                                $id_table_objet = 'id_article';
                            }

                            $contexte['objets'] = $table_objet;
                            $contexte[$id_table_objet] = $id_objet;
                        }
                    }
                }
            }
            
            return recuperer_fond($fond,$contexte);
    }
    
    return '';
}

?>