<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

include_spip('inc/ciwidget_inc_meta');
include_spip('inc/widget_commun');

function ciwidget_url_iframe($code=''){
    
    $url = ciwidget_extraire_src_iframe_ou_url($code);

    // verifier par rapport a la liste blanche (au cas ou elle a evoluee)
    if (ciwidget_lire_meta_cle('iframe','limiter_hosts')=='oui' 
        AND !ciwidget_verifier_url_dans_liste_blanche($url,ciwidget_lire_meta_cle('iframe','hosts_liste'))){
            $url = '';

    // verifier par rapport aux widgets dedies
    } elseif ($widget_dedie = ciwidget_url_identifier_widget_dedie($url)) {
            $url = '';
    }
    
    // cas des URL relatives
    if ($url AND !tester_url_absolue($url)) {
        if (substr($url,0,1)=='/'){
            $url = substr($url,1);
        }
        $url = _DIR_RACINE . $url;
    }
    
    return $url;
}

function ciwidget_iframe_ratio($largeur='',$hauteur=''){
    $ratio = '100%;';
    
    if (intval($largeur)>0 AND intval($hauteur)>0){
        $ratio = strval(round(100 * intval($hauteur) / intval($largeur),2)).'%;';
    }
    
    return $ratio;
}

?>