<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */


if (!defined('_ECRIRE_INC_VERSION')) return;

include_spip('inc/presentation');
include_spip('inc/actions');
include_spip('inc/autoriser');
include_spip('inc/documents');
include_spip('inc/filtres');
include_spip('inc/ciwidget_verifier');


function ciwidget_choiximporter($arg=''){
    $res1 = '';    $type_en_cours = '';

    $ret = ciwidget_importer_config();

    $res1 = debut_cadre_trait_couleur("", true, "", "");
    $res1 .= "<p><b>";
    if (isset($ret['erreurs'])){
        $res1 .= _T('ciwidget:traitement_echec')."</b>";
        foreach ($ret['erreurs'] AS $erreur){
            $res1 .= '<br>'.$erreur;
        }
    } else {
	$res1 .= _T('ciwidget:traitement_termine')."</b>";
        if (isset($ret['imports'])){
            foreach ($ret['imports'] AS $widget){
                if ($widget=='couleur') {
                    // eviter le doublon entre palette et couleur
                } else {
                    $res1 .= '<br>'.$widget;
                }
            }
        }
    }
    $res1 .= "</p>";
    $res1 .= fin_cadre_trait_couleur(true);

    $res1 .= '<div style="text-align:right;"><a href="'.generer_url_ecrire('configurer_ciwidget').'">'._T('icone_retour').'</a></div><div>&nbsp;</div>';

    return $res1;
}


function ciwidget_afficher_boite_upload() {
    $return = '';
    $texteon = _T('ciwidget:televerser_config');
    $texteoff = _T('ciwidget:config_a_importer');
	$document = false;
	$id_document = 0;
	$fichier = "";
	$date = "";
	$nom_cible = 'ciwidget_config.txt';

	$id_document = intval(_request("show_docs"));
	if ($id_document) {
		$row = sql_fetsel("*", "spip_documents", "id_document=".$id_document,"","");
		if ($row)
			$document = $row;
	}

	if ($document) {
		$id_document = $document['id_document'];
		$date = $document['date'];
		$fichier = $document['fichier'];
		$extension = $document['extension'];

		if ($extension!='txt') {
			// supprimer le fichier si l'extension n'est pas txt
			$row = sql_fetsel("*", "spip_documents_liens", "id_document=".$id_document,"","");
			if (!$row) {
				@unlink(_DIR_IMG . $fichier);
				sql_delete("spip_documents", "id_document=".$id_document);
			}
			$document = false;
			$return .= '<div class="formulaire_spip"><p class="reponse_formulaire reponse_formulaire_erreur">'._T("ciwidget:erreur_format_txt").'</p></div>';

		} else {
			// imposer le nom et l'emplacement du fichier
			if ($fichier!=$nom_cible) {
				$row = sql_fetsel("*", "spip_documents_liens", "id_document=".$id_document,"","");
				if (!$row) {
					$source = _DIR_IMG . $fichier;
					$destination = _DIR_IMG . $nom_cible;
					if (file_exists($destination))
						@unlink($destination);
					@rename($source, $destination);
					sql_updateq("spip_documents", array("fichier" => $nom_cible), "id_document=$id_document");
					$document['fichier'] = $nom_cible;
					$fichier = $nom_cible;
				}
			}
		}
	}


	// l'utilisateur veut supprimer le fichier
	if ($id_supprdoc = intval(_request('supprimer_doc'))) {
		$row = sql_fetsel("*", "spip_documents_liens", "id_document=".$id_supprdoc,"","");
		if (!$row) {
			$row2 = sql_fetsel("*", "spip_documents", "id_document=".$id_supprdoc,"","");
			if ($row2) {
				$fichier_suppr = $row2['fichier'];
				if ($fichier_suppr==$nom_cible) {
					@unlink(_DIR_IMG . $fichier_suppr);
					sql_delete("spip_documents", "id_document=".$id_supprdoc);
					$document = false;
				}
			}
		}
	}
	

	if ($document) {
		$return .= debut_cadre_trait_couleur("", true, "", $texteoff);
		
		$return .= "<div style='text-align: center;'>";
        	$return .= quete_logo_document($document, generer_url_entite($id_document, 'document', '', '', true), '', '', '', '');
		$return .= "</div>\n<div style='text-align: center;'>"
		. $fichier
		."</div>\n";
		
		$fond = 'doc-24.gif';
		$texte = _T('icone_supprimer_document');	
		$lien = generer_url_ecrire('ciwidget_config_import',"supprimer_doc=".$id_document);
		$return .= icone_horizontale($texte, $lien, $fond, "supprimer.gif", false);
		
		$res = "<br>";
		$res .= "<input type='hidden' name='show_docs' value=".$id_document." >";
		$res .= "<input type='hidden' name='choiximporter' value='oui'>";
	
        	$return .= generer_form_ecrire('ciwidget_config_import', $res, '', attribut_html(_T('ciwidget:bouton_import_config')));
		
		$return .= fin_cadre_trait_couleur(true);
	}
        
        return $return;
}

function ciwidget_importer_config() {
	$return = array();
	$document = false;
	$id_document = 0;
	$fichier = "";
	$date = "";
	$contenu = "";
	
	$id_document = intval(_request("show_docs"));
	if ($id_document) {
		$row = sql_fetsel("*", "spip_documents", "id_document=".$id_document,"","");
		if ($row)
			$document = $row;
	}

	if ($document) {
		$id_document = $document['id_document'];
		$date = $document['date'];
		$fichier = $document['fichier'];
	}	
	
	if ($document) {
		$handle = fopen(_DIR_IMG . $fichier, "r");
                if ($handle) {
                        while (!feof($handle)) {
                                $contenu .= fgets($handle, 4096);
                        }
                        fclose($handle);
                }
		
		// Suppression du fichier d'import
		sql_delete("spip_documents", "id_document=".$id_document);
		@unlink(_DIR_IMG . $fichier);

                // inserer en base de donnees
                $return = ciwidget_importer_contenu_config($contenu);
	}

	return $return;
}


function ciwidget_importer_contenu_config($contenu_fichier){
    $return = array();
    $tableau = array();
    $imports = array();
    $erreurs = array();
    $tableau_id_style_sans_element = array();
    $valeurs_possibles = ciwidget_tableau_id_widgets_avec_valeur_defaut();
    $valeurs_possibles[] = 'commun';
    $valeurs_possibles[] = 'couleur';
    $valeurs_possibles[] = 'palette';
    $valeurs_possibles[] = 'rgpd';
    $valeurs_possibles[] = 'styles';
    $exceptions = array('couleur','palette','styles');
    $ciwidget_config = array();
    if (isset($GLOBALS['meta']['ciwidget'])) {
        $ciwidget_config = @unserialize($GLOBALS['meta']['ciwidget']);
    }

    
    if ($contenu_fichier) {
         $tableau_initial = explode(';',$contenu_fichier);
         if ($tableau_initial[0]=='czo0OiJzdHlsZSI7czo1OiJ2YWxldXIiO3M6MjIyOiJhOjEx'){
             unset($tableau_initial[0]);
             foreach ($tableau_initial AS $valeur_et_contenu){
                    list($valeur,$contenu) = explode("|",$valeur_et_contenu);
                    $tableau[$valeur] = $contenu;
             }
             
            foreach ($tableau AS $valeur=>$contenu){
                
                if (in_array($valeur,$valeurs_possibles)){
                    
                    if ($contenu) {
                        $rows = unserialize(base64_decode($contenu));
                        if ($rows AND is_array($rows)){
                            if (in_array($valeur, $exceptions)){
                                if ($valeur == 'styles'){
                                    foreach ($rows as $style) {
                                        if (isset($style['id_style']) AND $id_style=$style['id_style']){
                                            $tableau_id_style = explode("_", $id_style);
                                            array_pop($tableau_id_style);
                                            $id_style_sans_element = implode("_", $tableau_id_style).'_';
                                            if (!in_array($id_style_sans_element,$tableau_id_style_sans_element)){
                                              $tableau_id_style_sans_element[] = $id_style_sans_element;
                                            }
                                        }
                                    }
                                    
                                    // supprimer les styles existants pour les widgets en question
                                    foreach ($tableau_id_style_sans_element as $id_style_sans_element) {
                                        		sql_delete('spip_cistyle_styles', 'id_style LIKE ' . sql_quote($id_style_sans_element . '%'));
                                    }
                                    
                                    // ajouter
                                    reset($rows);
                                    foreach ($rows as $style) {
                                        if (isset($style['id_style']) AND $id_style=$style['id_style']){
                                            sql_insertq('spip_cistyle_styles', $style);
                                        }
                                    }
                                    
                                } elseif (isset($rows[0]['valeur'])){
                                    $nom = $valeur;
                                    $valeurs_futures = array();
                                    if ($valeur == 'palette'){
                                        $valeurs_futures['valeur'] = intval($rows[0]['valeur']);
                                        $verif = intval($rows[0]['valeur']);
                                    } elseif ($valeur != 'styles'){
                                        $valeurs_futures['valeur'] = $rows[0]['valeur'];
                                        $verif = unserialize($rows[0]['valeur']);
                                    }

                                    if (!ciwidget_verifier_tableau($valeur,$verif,$valeur,true)){
                                        $erreurs[] = $valeur;
                                    } else {
                                        $imports[] = $valeur;
                                        $row = sql_fetsel('*', "spip_cistyle_config","nom='".$nom."'");
                                        if ($row) {
                                                sql_updateq("spip_cistyle_config", $valeurs_futures, "nom='".$nom."'");
                                        } else {
                                                $valeurs_futures['nom'] = $nom;
                                                sql_insertq('spip_cistyle_config', $valeurs_futures);
                                        }
                                    }
                                }
                            } else {
                                $imports[] = $valeur;
                                $ciwidget_config[$valeur] = $rows;    
                            }
                        }
                    }
                }
            }
            
            if ($imports){
                include_spip('inc/meta');
                ecrire_meta('ciwidget', @serialize($ciwidget_config));
            }
         } else {
            $erreurs[] = _T('ciwidget:valeur_incorrecte');
         }
     }
     
     if ($erreurs){
      	$return['erreurs'] = $erreurs;
     } else {
      	$return['imports'] = $imports;
        
        include_spip('inc/widget_commun');
        ciwidget_purger_cache_css();
        include_spip('inc/invalideur');
        suivre_invalideur("1");
     }
     
     return $return;
}

?>